---
title: llarp::layers::platform::OSTraffic
summary: platfrom datum that is used to read and write to the os 

---

# llarp::layers::platform::OSTraffic



platfrom datum that is used to read and write to the os 


`#include <os_traffic.hpp>`

## Public Functions

|                | Name           |
| -------------- | -------------- |
| | **[OSTraffic](Classes/structllarp_1_1layers_1_1platform_1_1OSTraffic.md#function-ostraffic)**() =default |
| | **[OSTraffic](Classes/structllarp_1_1layers_1_1platform_1_1OSTraffic.md#function-ostraffic)**([net::IPPacket](Classes/structllarp_1_1net_1_1IPPacket.md) )<br>construct from a valid ip packet.  |
| | **[OSTraffic](Classes/structllarp_1_1layers_1_1platform_1_1OSTraffic.md#function-ostraffic)**(EtherType_t kind, [PlatformAddr](Classes/structllarp_1_1layers_1_1platform_1_1PlatformAddr.md) src, [PlatformAddr](Classes/structllarp_1_1layers_1_1platform_1_1PlatformAddr.md) dst, std::vector< uint8_t > data) |
| std::string | **[ToString](Classes/structllarp_1_1layers_1_1platform_1_1OSTraffic.md#function-tostring)**() const |

## Public Attributes

|                | Name           |
| -------------- | -------------- |
| EtherType_t | **[kind](Classes/structllarp_1_1layers_1_1platform_1_1OSTraffic.md#variable-kind)** <br>the kind of traffic it is  |
| [PlatformAddr](Classes/structllarp_1_1layers_1_1platform_1_1PlatformAddr.md) | **[src](Classes/structllarp_1_1layers_1_1platform_1_1OSTraffic.md#variable-src)** <br>platform level source and destination addresses of this traffic  |
| [PlatformAddr](Classes/structllarp_1_1layers_1_1platform_1_1PlatformAddr.md) | **[dst](Classes/structllarp_1_1layers_1_1platform_1_1OSTraffic.md#variable-dst)**  |
| std::vector< uint8_t > | **[data](Classes/structllarp_1_1layers_1_1platform_1_1OSTraffic.md#variable-data)** <br>the datum itself  |

## Public Functions Documentation

### function OSTraffic

```cpp
OSTraffic() =default
```


### function OSTraffic

```cpp
explicit OSTraffic(
    net::IPPacket 
)
```

construct from a valid ip packet. 

### function OSTraffic

```cpp
OSTraffic(
    EtherType_t kind,
    PlatformAddr src,
    PlatformAddr dst,
    std::vector< uint8_t > data
)
```


### function ToString

```cpp
std::string ToString() const
```


## Public Attributes Documentation

### variable kind

```cpp
EtherType_t kind;
```

the kind of traffic it is 

### variable src

```cpp
PlatformAddr src;
```

platform level source and destination addresses of this traffic 

### variable dst

```cpp
PlatformAddr dst;
```


### variable data

```cpp
std::vector< uint8_t > data;
```

the datum itself 

-------------------------------

Updated on 2023-03-29 at 02:27:53 +0000